apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: echo           # label without consequences used to group resources
  name: echo
spec:
  replicas: 1
  selector:
    matchLabels:
      app: echo         # matches the replica labels / template.metadata.labels
  strategy:
    rollingUpdate:
      maxSurge: 25%
      maxUnavailable: 25%
    type: RollingUpdate
  template:
    metadata:
      labels:
        app: echo       # labels for the replica selector / selector.matchLabels
        tasty: mortadella
    spec:
      containers:
        - image: k8s.gcr.io/echoserver:1.4
          name: echoserver
          ports:
            - containerPort: 8080